unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, WndSub32, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Subc1: TSubclass32;
    Subc2: TSubclass32;
    Subc3: TSubclass32;
    lb1: TListBox;
    lb2: TListBox;
    SS1: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Item1: TMenuItem;
    Item2: TMenuItem;
    Item3: TMenuItem;
    Item4: TMenuItem;
    Item5: TMenuItem;
    Item6: TMenuItem;
    Label2: TLabel;
    MenuImg: TImage;
    Edit1: TMenuItem;
    StandardMenu1: TMenuItem;
    N1: TMenuItem;
    Items1: TMenuItem;
    More1: TMenuItem;
    Help1: TMenuItem;
    Items2: TMenuItem;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure LaunchExplorer;
    procedure CheckForExplorer;
    procedure SS1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Item1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    {$IFDEF VER100}    //if D3
    procedure Subc3MsgReceived(const Wnd: Integer; var Msg: Cardinal;
      var wParam, lParam: Integer; const ProcessId: Integer; rmFlag: TWhen;
      var return: Integer; var CallDefWndproc: Boolean);
    procedure Subc2MsgReceived(const Wnd: Integer; var Msg: Cardinal;
      var wParam, lParam: Integer; const ProcessId: Integer; rmFlag: TWhen;
      var return: Integer; var CallDefWndproc: Boolean);
    {$ENDIF}                                                     //for all Win32 Delphi version compatiblity
    {$IFDEF VER90}     //if D2
    procedure Subc3MsgReceived(const Wnd: Integer; var Msg: Cardinal;
      var wParam, lParam: Longint; const ProcessId: Integer; rmFlag: TWhen;
      var return: Longint; var CallDefWndproc: Boolean);
    procedure Subc2MsgReceived(const Wnd: Integer; var Msg: Cardinal;
      var wParam, lParam: Longint; const ProcessId: Integer; rmFlag: TWhen;
      var return: Longint; var CallDefWndproc: Boolean);
    {$ENDIF}
    {$IFDEF VER120}   //if D4
    procedure Subc3MsgReceived(const Wnd: HWND; var Msg: Cardinal;
       var wParam, lParam: Integer; const ProcessId: Cardinal; rmFlag: TWhen;
       var return: Integer; var CallDefWndproc: Boolean);
    procedure Subc2MsgReceived(const Wnd: HWND; var Msg: Cardinal;
       var wParam, lParam: Integer; const ProcessId: Cardinal; rmFlag: TWhen;
       var return: Integer; var CallDefWndproc: Boolean);
    {$ENDIF}
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  FileH = 20;      //"File" menu item height and width
  FileW = 23;

//return explorer's handle
function ExplorerHandle: hWnd;
begin
  result := FindWindow('ExploreWClass', nil);
end;

//launch explorer
procedure TForm1.LaunchExplorer;
var pi: TProcessInformation;
    si: TStartupInfo;
begin
  FillMemory(@si, sizeof(si), 0);
  si.cb := sizeof(si);
  CreateProcess(nil, 'explorer', nil, nil, False, NORMAL_PRIORITY_CLASS, nil, nil, si, pi);
  WaitForInputIdle(pi.hProcess, INFINITE);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
end;

//enumerate through child windows to find the one I'm looking for
function EnumChildCallback(wnd: hWnd; lparam: LPARAM): Boolean; stdcall;
type PhWnd = ^hWnd;
var cn: array[0..24] of char;
begin
  result := True;
  GetClassName(wnd, cn, 20);
  if (cn = 'SysTreeView32') then begin
    PhWnd(lparam)^ := wnd;
    result := False;
  end;
end;

procedure TForm1.CheckForExplorer;
begin
  if (ExplorerHandle = 0) and
     (Application.MessageBox('This demo needs Windows Explorer running, launch it now?',
                             'Confirm', MB_YESNO) = IDYes) then
    LaunchExplorer;
end;

procedure TForm1.SS1Click(Sender: TObject);
begin
  if not Subc1.start then begin
    CheckForExplorer;
    if ExplorerHandle = 0 then exit;
    Application.Messagebox('About to start subclass, click OK to continue', 'Info', MB_ICONINFORMATION);
    Subc1.WindowHandle := ExplorerHandle;
    EnumChildWindows(ExplorerHandle, @EnumChildCallback, longint(@Subc2.WindowHandle));  //could just use FindWindowEx
    ShowWindow(Subc1.WindowHandle, SW_SHOWNORMAL);                   //send in by reference
    SetForegroundWindow(Subc1.WindowHandle);
  end;
  Subc1.Start := not Subc1.Start;    //start the subclassing on both explorer windows (explorer and treeview)
  Subc2.Start := not Subc2.Start;
  if subc1.start then
    SS1.caption := 'Stop'
  else
    SS1.caption := 'Start';
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
    bmp: TBitmap;
begin
  Subc1.OnMsgReceived := Subc2MsgReceived;  //set these at run-time because how the methods are declared above with all
  Subc2.OnMsgReceived := Subc2MsgReceived;  //the $IFDEF's, Delphi has trouble setting them at design time
  Subc3.OnMsgReceived := Subc3MsgReceived;

  ModifyMenu(MainMenu1.handle, 0, MF_OWNERDRAW or MF_BYPOSITION, File1.command, nil);  //set "File" to owner-drawn
  for i := 0 to File1.count-1 do begin
    bmp := TBitmap.Create;
    with bmp do begin                  //go through each item, create a bitmap section for each one
      Width := MenuImg.Width;
      Height := MenuImg.Height div File1.count;
      Canvas.CopyRect(Rect(0, 0, Width, Height), MenuImg.Canvas, Rect(0, Height*i, Width, (Height*i) + Height));
      Canvas.Brush.Style := bsClear;
      Canvas.Font := Label2.Font;
      Canvas.TextOut(20, 0, File1.Items[i].Caption);
      ModifyMenu(File1.handle, i, MF_OWNERDRAW or MF_BYPOSITION, File1.Items[i].command, Pointer(bmp));
      File1.Items[i].tag := longint(Pointer(bmp));  //save bitmap here so we can dispose it later
    end;
  end;
  Subc3.WindowHandle := handle;   //start subclassing OUR window
  Subc3.start := True;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i: Integer;
begin
  for i := 0 to File1.count-1 do
    TBitmap(Pointer(File1.items[i].tag)).Free;  //free all of our bitmaps
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  subc1.start := False;
  subc2.start := False;  //be sure to set to false on close
  subc3.start := False;
end;

procedure TForm1.Item1Click(Sender: TObject);
begin
  ShowMessage(TMenuItem(Sender).caption+' clicked!');
end;

{$IFDEF VER100}    //if D3
procedure TForm1.Subc3MsgReceived(const Wnd: Integer; var Msg: Cardinal;
  var wParam, lParam: Integer; const ProcessId: Integer; rmFlag: TWhen;
  var return: Integer; var CallDefWndproc: Boolean);
{$ENDIF}
{$IFDEF VER90}    //if D2
procedure TForm1.Subc3MsgReceived(const Wnd: Integer; var Msg: Cardinal;
  var wParam, lParam: Longint; const ProcessId: Integer; rmFlag: TWhen;
  var return: Longint; var CallDefWndproc: Boolean);
{$ENDIF}
{$IFDEF VER120}    //if D4
procedure TForm1.Subc3MsgReceived(const Wnd: HWND; var Msg: Cardinal;
   var wParam, lParam: Integer; const ProcessId: Cardinal; rmFlag: TWhen;
   var return: Integer; var CallDefWndproc: Boolean);
{$ENDIF}
var offset: integer;
begin
  case Msg of
    WM_MEASUREITEM: with PMeasureItemStruct(lparam)^ do     //message fired to set the size of the items, LPARAM points to TMeasureItemStruct
                      if ItemID = File1.command then begin
                        ItemWidth := FileW;           //if "File", need to handle this seperately
                        ItemHeight := FileH;
                      end                             //set size of each item
                      else begin
                        ItemWidth := MenuImg.Width-10;
                        ItemHeight := MenuImg.Height div File1.count;
                      end;

    WM_DRAWITEM: with PDrawItemStruct(lparam)^, Canvas do begin  //message fired when drawing needs to be done, LPARAM points to TDrawItemStruct
                   Handle := hDC;
                   if ((ItemAction and ODA_SELECT <> 0) and (ItemState and ODS_SELECTED = 1)) or
                      (ItemID = File1.command) then
                     CopyMode := cmNotSrcCopy     //if item selected, set copy mode to NOT
                   else
                     CopyMode := cmSrcCopy;       //otherwise draw normally

                   if ItemID = File1.command then begin   //need to handle the "File" item seperately
                     Brush.color := clBtnFace;
                     FillRect(rcItem);
                     Brush.Style := bsClear;
                     offset := 0;   //handles where "File" caption is drawn
                     if (ItemAction and ODA_SELECT <> 0) and (ItemState and ODS_SELECTED <> 0) then begin
                       inc(offset);
                       DrawEdge(Canvas.handle, rcItem, EDGE_SUNKEN, BF_RECT);   //if selected, draw down
                     end
                     else
                       DrawEdge(Canvas.handle, rcItem, EDGE_RAISED, BF_RECT);   //if not selected, draw up
                     TextOut(rcItem.left+8+offset, rcItem.top+2+offset, File1.caption);
                   end
                   else  //draw the bitmap
                     Draw(rcItem.Left, rcItem.Top, TBitmap(ItemData));
                 end;
   end;
end;

{$IFDEF VER100}    //if D3
procedure TForm1.Subc2MsgReceived(const Wnd: Integer; var Msg: Cardinal;
  var wParam, lParam: Integer; const ProcessId: Integer; rmFlag: TWhen;
  var return: Integer; var CallDefWndproc: Boolean);
{$ENDIF}
{$IFDEF VER90}    //if D2
procedure TForm1.Subc2MsgReceived(const Wnd: Integer; var Msg: Cardinal;
  var wParam, lParam: Longint; const ProcessId: Integer; rmFlag: TWhen;
  var return: Longint; var CallDefWndproc: Boolean);
{$ENDIF}
{$IFDEF VER120}    //if D4
procedure TForm1.Subc2MsgReceived(const Wnd: HWND; var Msg: Cardinal;
   var wParam, lParam: Integer; const ProcessId: Cardinal; rmFlag: TWhen;
   var return: Integer; var CallDefWndproc: Boolean);
{$ENDIF}
var lb: TListbox;
begin
  if Wnd = Subc1.WindowHandle then      //using the same OnMsgReceived for Subc1 and Subc2, so decide which
    lb := lb1
  else
    lb := lb2;
  lb.items.add(subc2.MsgToStr(Msg));
  lb.perform(LB_SETTOPINDEX, lb.items.count-1, 0);
end;


end.
